%define cib_major 2
%define crmcluster_major 2
%define crmcommon_major 3
%define crmservice_major 1
%define lrmd_major 1
%define pengine_major 4
%define pe_rules_major 2
%define pe_status_major 4
%define stonithd_major 2
%define transitioner_major 2

%define cib_libname %mklibname cib %cib_major
%define crmcluster_libname %mklibname crmcluster %crmcluster_major
%define crmcommon_libname %mklibname crmcommon %crmcommon_major
%define crmservice_libname %mklibname crmservice %crmservice_major
%define lrmd_libname %mklibname lrmd %lrmd_major
%define pengine_libname %mklibname pengine %pengine_major
%define pe_rules_libname %mklibname pe_rules %pe_rules_major
%define pe_status_libname %mklibname pe_status %pe_status_major
%define stonithd_libname %mklibname stonithd %stonithd_major
%define transitioner_libname %mklibname transitioner %transitioner_major

%define develname %mklibname -d pacemaker

%global gname haclient
%global uname hacluster
%global pcmk_docdir %{_docdir}/%{name}

# Supported cluster stacks, must support at least one
%bcond_with cman
%bcond_without corosync
%bcond_with heartbeat

# ESMTP is not available in RHEL, only in EPEL. Allow people to build
# the RPM without ESMTP in case they choose not to use EPEL packages
%bcond_without esmtp

# SNMP trap support only works with Net-SNMP 5.4 and above
%bcond_without snmp

# Support additional trace logging
%bcond_with tracedata

# We generate some docs using Publican, but its not available everywhere
%bcond_with publican

%global specversion 2
%global git_hash 394e906

%global pcmk_release %{?alphatag:0.}%{specversion}%{?alphatag:.%{alphatag}}%{?dist}

# Compatibility macros for distros that don't provide Python macros by default.
# Do this instead of trying to conditionally include
#   {_rpmconfigdir}/macros.python which doesn't always exist
%{!?py_ver:    %{expand: %%global py_ver      %%(echo `python -c "import sys; print sys.version[:3]"`)}}
%{!?py_prefix: %{expand: %%global py_prefix   %%(echo `python -c "import sys; print sys.prefix"`)}}
%{!?py_libdir:	%{expand: %%global py_libdir   %%{expand:%%%%{py_prefix}/%%%%{_lib}/python%%%%{py_ver}}}}
%{!?py_sitedir: %{expand: %%global py_sitedir %%{expand:%%%%{py_libdir}/site-packages}}}

Name:		pacemaker
Summary:	Scalable High-Availability cluster resource manager
Version:	1.1.16
Release:	%mkrel 1
License:	GPLv2+ and LGPLv2+
Url:		http://www.clusterlabs.org
Group:		System/Base
Source0:	%{name}-Pacemaker-%{version}.zip
#Patch1:		001-makefile-cleanup.patch  
#Patch2:		002-build-cleanup.patch  
#Patch3:		003-harden-toolchain.patch
Requires(pre):	cluster-glue
Requires:	resource-agents
Requires(post):  rpm-helper >= 0.24.8-1
Requires(preun): rpm-helper >= 0.24.8-1

# Required for core functionality
BuildRequires:	automake 
BuildRequires:	autoconf 
BuildRequires:	libtool 
BuildRequires:	pkgconfig 
BuildRequires:	libltdl-devel 
BuildRequires:	python-devel
BuildRequires:	glib2-devel 
BuildRequires:	cluster-glue-devel 
BuildRequires:	libxml2-devel 
BuildRequires:	libxslt-devel 
BuildRequires:	libuuid-devel
BuildRequires:	pkgconfig python-devel gcc-c++ bzip2-devel gnutls-devel pam-devel
BuildRequires:	pkgconfig(systemd)
BuildRequires:	dbus-devel

# Enables optional functionality
BuildRequires:	help2man 
BuildRequires:	ncurses-devel 
BuildRequires:	openssl-devel  
BuildRequires:	docbook-style-xsl 
BuildRequires:	resource-agents
BuildRequires:	xsltproc

%if %{with esmtp}
BuildRequires:	libesmtp-devel
%endif

%if %{with snmp}
BuildRequires:	net-snmp-devel >= 5.4
Requires:	net-snmp >= 5.4
%endif

%if %{with corosync}
BuildRequires:	corosync-devel
%endif

%if %{with cman}
BuildRequires:	cluster-devel
%endif

%if %{with heartbeat}
BuildRequires:	heartbeat-devel 
BuildRequires:	heartbeat-libs
%endif

%if %{with publican}
%ifarch %{ix86} x86_64
BuildRequires:	publican
%endif
%endif

%description
Pacemaker is an advanced, scalable High-Availability cluster resource
manager for Linux-HA (Heartbeat) and/or OpenAIS.

It supports "n-node" clusters with significant capabilities for
managing resources and dependencies.

It will run scripts at initialization, when machines go up or down,
when related resources fail and can be configured to periodically check
resource health.

%package -n %cib_libname
License:	GPLv2+ and LGPLv2+
Group:		System/Libraries
Summary:	Library used by the Pacemaker cluster resource manager and its clients
%package -n %crmcluster_libname
License:	GPLv2+ and LGPLv2+
Group:		System/Libraries
Summary:	Library used by the Pacemaker cluster resource manager and its clients
%package -n %crmcommon_libname
License:	GPLv2+ and LGPLv2+
Group:		System/Libraries
Summary:	Library used by the Pacemaker cluster resource manager and its clients
%package -n %crmservice_libname
License:	GPLv2+ and LGPLv2+
Group:		System/Libraries
Summary:	Library used by the Pacemaker cluster resource manager and its clients
%package -n %lrmd_libname
License:	GPLv2+ and LGPLv2+
Group:		System/Libraries
Summary:	Library used by the Pacemaker cluster resource manager and its clients
%package -n %pengine_libname
License:	GPLv2+ and LGPLv2+
Group:		System/Libraries
Summary:	Library used by the Pacemaker cluster resource manager and its clients
%package -n %pe_rules_libname
License:	GPLv2+ and LGPLv2+
Group:		System/Libraries
Summary:	Library used by the Pacemaker cluster resource manager and its clients
%package -n %pe_status_libname
License:	GPLv2+ and LGPLv2+
Group:		System/Libraries
Summary:	Library used by the Pacemaker cluster resource manager and its clients
%package -n %stonithd_libname
License:	GPLv2+ and LGPLv2+
Group:		System/Libraries
Summary:	Library used by the Pacemaker cluster resource manager and its clients
%package -n %transitioner_libname
License:	GPLv2+ and LGPLv2+
Group:		System/Libraries
Summary:	Library used by the Pacemaker cluster resource manager and its clients

%description -n %cib_libname
Library used by the Pacemaker cluster resource manager and its clients

%description -n %crmcluster_libname
Library used by the Pacemaker cluster resource manager and its clients

%description -n %crmcommon_libname
Library used by the Pacemaker cluster resource manager and its clients

%description -n %crmservice_libname
Library used by the Pacemaker cluster resource manager and its clients

%description -n %lrmd_libname
Library used by the Pacemaker cluster resource manager and its clients

%description -n %pengine_libname
Library used by the Pacemaker cluster resource manager and its clients

%description -n %pe_rules_libname
Library used by the Pacemaker cluster resource manager and its clients

%description -n %pe_status_libname
Library used by the Pacemaker cluster resource manager and its clients

%description -n %stonithd_libname
Library used by the Pacemaker cluster resource manager and its clients

%description -n %transitioner_libname
Library used by the Pacemaker cluster resource manager and its clients

%package -n %{develname}
License:	GPLv2+ and LGPLv2+
Summary:	Pacemaker development package
Group:		System/Libraries
Requires:	%cib_libname = %{version}-%{release}
Requires:	%crmcluster_libname = %{version}-%{release}
Requires:	%crmcommon_libname = %{version}-%{release}
Requires:	%crmservice_libname = %{version}-%{release}
Requires:	%lrmd_libname = %{version}-%{release}
Requires:	%pengine_libname = %{version}-%{release}
Requires:	%pe_rules_libname = %{version}-%{release}
Requires:	%pe_status_libname = %{version}-%{release}
Requires:	%stonithd_libname = %{version}-%{release}
Requires:	%transitioner_libname = %{version}-%{release}
Requires:	cluster-glue-devel libltdl-devel
Provides:	%{name}-devel = %{version}-%{release}
%if %{with corosync}
Requires:	corosync-devel
%endif
%if %{with heartbeat}
Requires:	heartbeat-devel
%endif

%description -n %{develname}
Headers and shared libraries for developing tools for Pacemaker.

Pacemaker is an advanced, scalable High-Availability cluster resource
manager for Linux-HA (Heartbeat) and/or OpenAIS.

It supports "n-node" clusters with significant capabilities for
managing resources and dependencies.

It will run scripts at initialization, when machines go up or down,
when related resources fail and can be configured to periodically check
resource health.

%package	cts
License:	GPLv2+ and LGPLv2+
Summary:	Test framework for cluster-related technologies like Pacemaker
Group:		System/Base
Requires:	python

%description	cts
Test framework for cluster-related technologies like Pacemaker

%package	doc
License:	GPLv2+ and LGPLv2+
Summary:	Documentation for Pacemaker
Group:		Documentation
BuildArch:	noarch

%description	doc
Documentation for Pacemaker.

Pacemaker is an advanced, scalable High-Availability cluster resource
manager for OpenAIS/Corosync.

It supports "n-node" clusters with significant capabilities for
managing resources and dependencies.

It will run scripts at initialization, when machines go up or down,
when related resources fail and can be configured to periodically check
resource health.

%prep
%setup -q -n %name-Pacemaker-%{version}
#%autopatch -p1

%build
./autogen.sh

%{configure2_5x}					\
	%{!?with_heartbeat: --without-heartbeat}	\
	%{!?with_corosync:  --without-corosync}		\
	%{!?with_esmtp:     --without-esmtp}		\
	%{!?with_snmp:      --without-snmp}		\
	%{?with_cman:       --with-cman}		\
	%{?with_profiling:  --with-profiling}		\
	%{?with_gcov:       --with-gcov}		\
	%{?with_tracedata   --with-tracedata}		\
	--with-version=%{version}-%{release}		\
	--docdir=%{pcmk_docdir}				\
	--localstatedir=%{_var}				\
	--enable-fatal-warnings=no			\
	--disable-ansi					\
	--enable-systemd


%make

%install
%makeinstall_std

mkdir -p ${RPM_BUILD_ROOT}%{_sysconfdir}/sysconfig
install -m 644 mcp/pacemaker.sysconfig ${RPM_BUILD_ROOT}%{_sysconfdir}/sysconfig/pacemaker

# Scripts that should be executable
chmod a+x %{buildroot}/%{_datadir}/pacemaker/tests/cts/CTSlab.py

# These are not actually scripts
find %{buildroot} -name '*.xml' -type f -print0 | xargs -0 chmod a-x
find %{buildroot} -name '*.xsl' -type f -print0 | xargs -0 chmod a-x
find %{buildroot} -name '*.rng' -type f -print0 | xargs -0 chmod a-x
find %{buildroot} -name '*.dtd' -type f -print0 | xargs -0 chmod a-x
 
# Dont package static libs or compiled python
find %{buildroot} -name '*.a' -type f -print0 | xargs -0 rm -f
find %{buildroot} -name '*.la' -type f -print0 | xargs -0 rm -f

# Don't package these either
rm -f %{buildroot}/%{_libdir}/heartbeat/hb2openais-helper.*
rm -f %{buildroot}/%{_libdir}/heartbeat/crm_primitive.*
rm -f %{buildroot}/%{_libdir}/service_crm.so
rm -f %{buildroot}/usr/lib/ocf/resource.d/pacemaker/pingd

# Don't package old initscripts
rm -f %{buildroot}/etc/init.d/pacemaker
rm -f %{buildroot}/etc/init.d/pacemaker_remote

%files
###########################################################
%exclude %{_datadir}/pacemaker/tests

%config(noreplace) %{_sysconfdir}/sysconfig/pacemaker
%{_sysconfdir}/logrotate.d/pacemaker
%{_unitdir}/pacemaker.service
%{_unitdir}/crm_mon.service
%{_unitdir}/pacemaker_remote.service
%{_sbindir}/pacemakerd
%{_datadir}/pacemaker
%{_datadir}/snmp/mibs/PCMK-MIB.txt
%{_sbindir}/cibadmin
%{_sbindir}/crm_attribute
%{_sbindir}/crm_diff
%{_sbindir}/crm_failcount
%{_sbindir}/crm_master
%{_sbindir}/crm_mon
%{_sbindir}/crm_simulate
%{_sbindir}/crm_resource
%{_sbindir}/crm_report
%{_sbindir}/crm_standby
%{_sbindir}/crm_ticket
%{_sbindir}/crm_verify
%{_sbindir}/crmadmin
%{_sbindir}/iso8601
%{_sbindir}/attrd_updater
%{_sbindir}/crm_shadow
%{_sbindir}/crm_error
%{_sbindir}/crm_node
%{_sbindir}/fence_legacy
%{_sbindir}/fence_pcmk
%{_sbindir}/stonith_admin
#%{_bindir}/disable_rgmanager
#%{_bindir}/ccs2cib
#%{_bindir}/ccs_flatten
%{_sbindir}/pacemaker_remoted
%{_libexecdir}/pacemaker
%{_mandir}/man7/crmd.7*
%{_mandir}/man7/ocf_pacemaker_*
%{_mandir}/man7/pengine.7*
%{_mandir}/man7/stonithd.7*
%{_mandir}/man8/attrd_updater.8*
%{_mandir}/man8/stonith_admin.8*
%{_mandir}/man8/cibadmin.8*
%{_mandir}/man8/crmadmin.8*
%{_mandir}/man8/crm_*
%{_mandir}/man8/fence_legacy.8*
%{_mandir}/man8/iso8601.8*
%{_mandir}/man8/pacemakerd.8*
%{_mandir}/man8/pacemaker_remoted.8*
%{_mandir}/man8/fence_pcmk.8*

# Packaged elsewhere
%exclude %{_datadir}/pacemaker/tests

#%doc COPYING README.markdown acls.html acls.txt crm_fencing.html crm_fencing.txt 
#%doc licenses

#%dir %attr (750, %{uname}, %{gname}) %{_var}/lib/heartbeat/crm
#%dir %attr (750, %{uname}, %{gname}) %{_var}/lib/pengine
%dir /usr/lib/ocf
%dir /usr/lib/ocf/resource.d
/usr/lib/ocf/resource.d/pacemaker
/usr/lib/ocf/resource.d/.isolation/docker-wrapper

%files -n %cib_libname
%{_libdir}/libcib.so.*
%files -n %crmcluster_libname
%{_libdir}/libcrmcluster.so.*
%files -n %crmcommon_libname
%{_libdir}/libcrmcommon.so.*
%files -n %crmservice_libname
%{_libdir}/libcrmservice.so.*
%files -n %lrmd_libname
%{_libdir}/liblrmd.so.*
%files -n %pengine_libname
%{_libdir}/libpengine.so.*
%files -n %pe_rules_libname
%{_libdir}/libpe_rules.so.*
%files -n %pe_status_libname
%{_libdir}/libpe_status.so.*
%files -n %stonithd_libname
%{_libdir}/libstonithd.so.*
%files -n %transitioner_libname
%{_libdir}/libtransitioner.so.*

%files doc
%doc %{pcmk_docdir}

%files cts
%{py_platsitedir}/cts
%{_datadir}/pacemaker/tests/cts

%files -n %{develname}
%exclude %{_datadir}/pacemaker/tests/cts
%{_datadir}/pacemaker/tests
%{_includedir}/pacemaker
%{_libdir}/*.so
%{_libdir}/pkgconfig/*.pc


%changelog
* Tue Mar 07 2017 ennael <ennael> 1.1.16-1.mga6
+ Revision: 1089610
- new version 1.1.16

* Mon Jan 11 2016 luigiwalser <luigiwalser> 1.1.8-10.mga6
+ Revision: 921830
- rebuild for gnutls

* Wed Oct 15 2014 umeabot <umeabot> 1.1.8-9.mga5
+ Revision: 740722
- Second Mageia 5 Mass Rebuild

* Tue Sep 16 2014 umeabot <umeabot> 1.1.8-8.mga5
+ Revision: 683303
- Mageia 5 Mass Rebuild

  + pterjan <pterjan>
    - Rebuild for new Python

* Sun Jan 12 2014 philippem <philippem> 1.1.8-6.mga4
+ Revision: 566353
- applied upstream patch to fix CVE-2013-0281 mga#11724

* Fri Oct 18 2013 umeabot <umeabot> 1.1.8-5.mga4
+ Revision: 521353
- Mageia 4 Mass Rebuild

* Mon Jan 21 2013 fwang <fwang> 1.1.8-4.mga3
+ Revision: 390549
- cleanup spec

* Mon Jan 21 2013 fwang <fwang> 1.1.8-3.mga3
+ Revision: 390468
- revise patch so that files are not need to be copied

* Mon Jan 21 2013 fwang <fwang> 1.1.8-2.mga3
+ Revision: 390417
- location moved
- more linkage fix
- fix patch
- more patch
- move libpe_rules out of pengine so that link order is correct
- more linkage fix
- apply link patch
- correct link patch

* Sun Jan 20 2013 colin <colin> 1.1.8-1.mga3
+ Revision: 390172
- Fix build after previous (non-built) upgrades
- Don't bother ghosting the rundir (no other pkgs do this)

  + umeabot <umeabot>
    - Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

  + ennael <ennael>
    - fix pengine Makefile.am
    - new version
    - AM_CONFIG_HEADER fix

* Fri Nov 30 2012 pterjan <pterjan> 1.1.7-3.mga3
+ Revision: 323262
- Hide an expected failure from iurt, else it will ignore that the rpm actually built
- Add upstream patch fixing missing headers

* Sat Apr 28 2012 tmb <tmb> 1.1.7-2.mga2
+ Revision: 233833
- Require rpm-helper >= 0.24.8-1 for systemd support

* Fri Apr 20 2012 boklm <boklm> 1.1.7-1.mga2
+ Revision: 232064
- version 1.1.7
- remove old patchs
- rename ais bcond to corosync
- enable systemd
- disable cman

* Mon Apr 02 2012 ennael <ennael> 1.1.6-3.mga2
+ Revision: 227906
- fix wrong buildrequires

* Mon Apr 02 2012 ennael <ennael> 1.1.6-2.mga2
+ Revision: 227901
- remove wrong require

* Mon Apr 02 2012 boklm <boklm> 1.1.6-1.mga2
+ Revision: 227883
- add xsltproc as BR, needed to generate man pages
- split libraries in different packages
- update to version 2.1.6
- drop patchs merged upstream
- update makefile patch
- remove patch splitting pengine directory, but run multiple make to avoid
  link failure, as temporary solution until upstream split the directory
  (thanks to rtp for help)
- re-enable cman
- disable cman and heartbeat
- imported package pacemaker

  + ennael <ennael>
    - fix man pages
    - clean spec (man pages, provides, group)
    - fix groups
    - add missing files
    - add patch for ocf-shellfuncs
    - patch for ocf-shellfuncs path
    - fix release tag and group
    - fix more buildrequires
    - fix buildrequires

  + rtp <rtp>
    - Fix multiples build errors.

